{}
{ Project : ArraySortDemo.dpr                                             }
{ Comment :                                                               }
{                                                                         }
{    Date : 10/05/2012 17:58:15                                           }
{  Author : Cirec http://www.delphifr.com/auteur/CIREC/311214.aspx        }
{}
{ Last modified                                                           }
{    Date : 22/05/2012 17:16:16                                           }
{  Author : Cirec http://www.delphifr.com/auteur/CIREC/311214.aspx        }
{}
unit UArraySortMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask;

type
  TfrmArraySort = class(TForm)
    mmoInitial: TMemo;
    mmoResult: TMemo;
    btnSort234: TButton;
    btnSort4321: TButton;
    btnSort32: TButton;
    MaskEdit1: TMaskEdit;
    btnCustomSort: TButton;
    lblArray: TLabel;
    rbtnAscending: TRadioButton;
    rbtnDescending: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure btnSort234Click(Sender: TObject);
    procedure btnSort4321Click(Sender: TObject);
    procedure btnSort32Click(Sender: TObject);
    procedure MaskEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure btnCustomSortClick(Sender: TObject);
    procedure rbtnAscendingClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure AfficheArray(const aMemo: TMemo);
    procedure AfficheArrayAsc(const aMemo: TMemo);
    procedure AfficheArrayDesc(const aMemo: TMemo);
  public
    { Dclarations publiques }
    function ArrayCompare(const Item1, Item2: Integer): Integer;
    procedure ArrayExchange(const Item1, Item2: Integer);
  end;

var
  frmArraySort: TfrmArraySort;

implementation

{$R *.dfm}
uses USorts, Math;
type
  PIntArray = ^TIntArray;
  TIntArray = array[0..16] of Integer;
  TArrayOfIntArray = array of PIntArray;
var
  Array1: TIntArray = (552, 337, 385, 264, 18, 461, 442, 321, 632, 371, 90, 311, 50, 157, 345, 122, 32);
  Array2: TIntArray = (610, 433, 433, 422, 421,357, 337, 337, 440, 314, 502, 440, 290, 680, 201, 172, 107);
  Array3: TIntArray = (40, 30, 71, 30, 20, 40, 40, 225, 30, 40, 20, 70, 40, 225, 27, 30, 30);
  Array4: TIntArray = (600, 432, 608, 620, 467, 471, 540, 517, 452, 488, 591, 522, 489, 856, 723, 431, 486);

  CompareArray, ExchangeArray: TArrayOfIntArray;
const
  aLine = '%d'#9'%d'#9'%d'#9'%d';
{ TfrmArraySort }

procedure TfrmArraySort.AfficheArray(const aMemo: TMemo);
begin
  if rbtnDescending.Checked then
    AfficheArrayDesc(aMemo)
  else
  AfficheArrayAsc(aMemo);
end;

procedure TfrmArraySort.AfficheArrayAsc(const aMemo: TMemo);
var
 Idx: Integer;
begin
  aMemo.Clear;
  for Idx := 0 to 16 do
    aMemo.Lines.Add(Format(aLine, [Array1[Idx], Array2[Idx], Array3[Idx], Array4[Idx]]))
end;
// affichage inverse pour simuler le tri dcroissant
procedure TfrmArraySort.AfficheArrayDesc(const aMemo: TMemo);
var
 Idx: Integer;
begin
  aMemo.Clear;
  for Idx := 16 downto 0 do
    aMemo.Lines.Add(Format(aLine, [Array1[Idx], Array2[Idx], Array3[Idx], Array4[Idx]]))
end;

procedure TfrmArraySort.FormCreate(Sender: TObject);
begin
  lblArray.Caption := Format(aLine, [1, 2, 3, 4]);
  SetLength(ExchangeArray, 4);
  ExchangeArray[0] := @Array1;
  ExchangeArray[1] := @Array2;
  ExchangeArray[2] := @Array3;
  ExchangeArray[3] := @Array4;
  AfficheArrayAsc(mmoInitial);
end;

function TfrmArraySort.ArrayCompare(const Item1, Item2: Integer): Integer;
var
  I: Integer;
begin
  Result := 0;
  for I := Low(CompareArray) to High(CompareArray) do
  begin
    Result := CompareValue(CompareArray[I]^[Item1], CompareArray[I]^[Item2]);
    if Result <> 0 then Break;
  end;
end;

procedure TfrmArraySort.ArrayExchange(const Item1, Item2: Integer);
var
  I, TmpValue: Integer;
begin
  for I := Low(ExchangeArray) to High(ExchangeArray) do
  begin
    TmpValue := ExchangeArray[I]^[Item1];
    ExchangeArray[I]^[Item1] := ExchangeArray[I]^[Item2];
    ExchangeArray[I]^[Item2] := TmpValue;
  end;
end;

//Trier 2me 3me puis 4me colone
procedure TfrmArraySort.btnSort234Click(Sender: TObject);
begin
  SetLength(CompareArray, 3);
  CompareArray[0] := @Array2;
  CompareArray[1] := @Array3;
  CompareArray[2] := @Array4;
  SortAnything(Low(Array1), High(Array1), ArrayCompare, ArrayExchange, aQuickSort);
  AfficheArray(mmoResult);
end;

//Trier 4me 3me 2me puis 1re colone
procedure TfrmArraySort.btnSort4321Click(Sender: TObject);
begin
  SetLength(CompareArray, 4);
  CompareArray[0] := @Array4;
  CompareArray[1] := @Array3;
  CompareArray[2] := @Array2;
  CompareArray[3] := @Array1;
  SortAnything(Low(Array1), High(Array1), ArrayCompare, ArrayExchange, aQuickSort);
  AfficheArray(mmoResult);
end;

//Trier 3me puis 2me colone
procedure TfrmArraySort.btnSort32Click(Sender: TObject);
begin
  SetLength(CompareArray, 2);
  CompareArray[0] := @Array3;
  CompareArray[1] := @Array2;
  SortAnything(Low(Array1), High(Array1), ArrayCompare, ArrayExchange, aQuickSort);
  AfficheArray(mmoResult);
end;

procedure TfrmArraySort.btnCustomSortClick(Sender: TObject);
var
  NbArray, I: Integer;
begin
  NbArray := length(MaskEdit1.Text);
  SetLength(CompareArray, NbArray);
  if NbArray = 0 then
    Exit;
  for I := 1 to NbArray do
    CompareArray[I-1] := ExchangeArray[StrToInt(MaskEdit1.Text[I])-1];

  SortAnything(Low(Array1), High(Array1), ArrayCompare, ArrayExchange, aQuickSort);
  AfficheArray(mmoResult);
  //ShowMessage(IntToStr(length(MaskEdit1.Text))+' '+MaskEdit1.Text);
end;

procedure TfrmArraySort.MaskEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    btnCustomSort.Click;
    Exit;
  end;
  if not (key in ['1'..'4']) then
    Key := #0;
end;

procedure TfrmArraySort.rbtnAscendingClick(Sender: TObject);
begin
  AfficheArray(mmoResult);
end;

end.
